/*
 *
 *  Copyright (C) 1996-2001, OFFIS
 *
 *  This software and supporting documentation were developed by
 *
 *    Kuratorium OFFIS e.V.
 *    Healthcare Information and Communication Systems
 *    Escherweg 2
 *    D-26121 Oldenburg, Germany
 *
 *  THIS SOFTWARE IS MADE AVAILABLE,  AS IS,  AND OFFIS MAKES NO  WARRANTY
 *  REGARDING  THE  SOFTWARE,  ITS  PERFORMANCE,  ITS  MERCHANTABILITY  OR
 *  FITNESS FOR ANY PARTICULAR USE, FREEDOM FROM ANY COMPUTER DISEASES  OR
 *  ITS CONFORMITY TO ANY SPECIFICATION. THE ENTIRE RISK AS TO QUALITY AND
 *  PERFORMANCE OF THE SOFTWARE IS WITH THE USER.
 *
 *  Module:  wlistctn
 *
 *  Author:  Andrew Hewett
 *
 *  Purpose: Service Class Executive (SCE) - ECHO Service Class Provider
 *
 *  Last Update:      $Author: meichel $
 *  Update Date:      $Date: 2001/10/12 12:02:28 $
 *  Source File:      $Source: /share/dicom/cvs-depot/dcmtk/wlistctn/apps/sceecho.cc,v $
 *  CVS/RCS Revision: $Revision: 1.9 $
 *  Status:           $State: Exp $
 *
 *  CVS/RCS Log at end of file
 *
 */

#include "osconfig.h"    /* make sure OS specific configuration is included first */

#ifdef HAVE_STDLIB_H
#ifndef  _BCB4
/* workaround for bug in Borland C++ Builder 4 */
BEGIN_EXTERN_C
#endif
#include <stdlib.h>
#ifndef  _BCB4
END_EXTERN_C
#endif
#endif

BEGIN_EXTERN_C
#include <stdio.h>
#include <string.h>
END_EXTERN_C

#include "dicom.h"
#include "wlistctn.h"
#include "dimse.h"

#include "sceecho.h"

/*
 * C-ECHO SCP
 */

OFCondition
SCE_echoSCP(T_ASC_Association * assoc, T_DIMSE_C_EchoRQ * req,
	T_ASC_PresentationContextID presId)
{
    if (opt_verbose) {
	printf("Received Echo SCP RQ: MsgID %d\n", 
		req->MessageID);
    }
    /* we send an echo response back */
    OFCondition cond = DIMSE_sendEchoResponse(assoc, presId, 
        req, STATUS_Success, NULL);
    
    if (cond.bad()) {
	errmsg("echoSCP: Echo Response Failed:");
	DimseCondition::dump(cond);
    }
    return cond;
}

/*
** CVS Log
** $Log: sceecho.cc,v $
** Revision 1.9  2001/10/12 12:02:28  meichel
** Adapted wlistctn to OFCondition based dcmnet module (supports strict mode).
**
** Revision 1.8  2001/06/01 15:51:43  meichel
** Updated copyright header
**
** Revision 1.7  2000/03/08 16:37:44  meichel
** Updated copyright header.
**
** Revision 1.6  2000/02/23 15:13:54  meichel
** Corrected macro for Borland C++ Builder 4 workaround.
**
** Revision 1.5  2000/02/01 11:00:58  meichel
** Avoiding to include <stdlib.h> as extern "C" on Borland C++ Builder 4,
**   workaround for bug in compiler header files.
**
** Revision 1.4  1999/04/26 12:59:10  meichel
** Ported Worklist CTN to Win32 environment.
**
** Revision 1.3  1996/09/27 08:54:26  hewett
** Enclosed system include files with BEGIN_EXTERN_C/END_EXTERN_C
**
** Revision 1.2  1996/08/29 16:16:07  hewett
** Corrected copyright header.
**
** Revision 1.1.1.1  1996/04/26 14:16:01  hewett
** Initial Import.
**
*/
